Initialize a `Runner` for the given `suite`.

see

  https://mochajs.org/api/Mocha.Runner.html

### Hierarchy

- EventEmitter
- EventEmitter
- EventEmitter
- EventEmitter
- EventEmitter
- EventEmitter
- EventEmitter
- EventEmitter
- EventEmitter
- EventEmitter
- EventEmitter
- EventEmitter
  - Runner

## Index

### Constructors

- constructor

### Properties

- _abort
- _defaultGrep
- _delay
- _globals
- allowUncaught
- asyncOnly
- currentRunnable
- failures
- forbidOnly
- forbidPending
- fullStackTrace
- hookErr
- ignoreLeaks
- next
- nextSuite
- prevGlobalsLength
- started
- stats
- suite
- test
- total

### Methods

- abort
- addListener
- checkGlobals
- emit
- eventNames
- fail
- failHook
- getMaxListeners
- globalProps
- globals
- grep
- grepTotal
- hook
- hookDown
- hookUp
- hooks
- listenerCount
- listeners
- off
- on
- once
- parents
- prependListener
- prependOnceListener
- rawListeners
- removeAllListeners
- removeListener
- run
- runSuite
- runTest
- runTests
- setMaxListeners
- uncaught
- immediately

## Constructors

### constructor

- new Runner(suite: Suite, delay: boolean): Runner
- new Runner(suite: ISuite, delay: boolean): Runner

- - Defined in node_modules/@types/mocha/index.d.ts:1363

  #### Parameters

  - ##### suite: Suite

  - ##### delay: boolean

  #### Returns Runner

- - Defined in node_modules/@types/mocha/index.d.ts:1365
  deprecated

    Use the overload that accepts `Mocha.Suite` instead.

  #### Parameters

  - ##### suite: ISuite

  - ##### delay: boolean

  #### Returns Runner

## Properties

### Private _abort

_abort: any

- Defined in node_modules/@types/mocha/index.d.ts:1357

### Private _defaultGrep

_defaultGrep: any

- Defined in node_modules/@types/mocha/index.d.ts:1359

### Private _delay

_delay: any

- Defined in node_modules/@types/mocha/index.d.ts:1358

### Private _globals

_globals: any

- Defined in node_modules/@types/mocha/index.d.ts:1356

### Optional allowUncaught

allowUncaught: undefined | false | true

- Defined in node_modules/@types/mocha/index.d.ts:1375

### Optional asyncOnly

asyncOnly: undefined | false | true

- Defined in node_modules/@types/mocha/index.d.ts:1374

### Optional currentRunnable

currentRunnable: Runnable

- Defined in node_modules/@types/mocha/index.d.ts:1381

### failures

failures: number

- Defined in node_modules/@types/mocha/index.d.ts:1373

### Optional forbidOnly

forbidOnly: undefined | false | true

- Defined in node_modules/@types/mocha/index.d.ts:1377

### Optional forbidPending

forbidPending: undefined | false | true

- Defined in node_modules/@types/mocha/index.d.ts:1378

### Optional fullStackTrace

fullStackTrace: undefined | false | true

- Defined in node_modules/@types/mocha/index.d.ts:1376

### Private hookErr

hookErr: any

- Defined in node_modules/@types/mocha/index.d.ts:1361

### Optional ignoreLeaks

ignoreLeaks: undefined | false | true

- Defined in node_modules/@types/mocha/index.d.ts:1379

### Private next

next: any

- Defined in node_modules/@types/mocha/index.d.ts:1360

### Private nextSuite

nextSuite: any

- Defined in node_modules/@types/mocha/index.d.ts:1363

### Private prevGlobalsLength

prevGlobalsLength: any

- Defined in node_modules/@types/mocha/index.d.ts:1362

### started

started: boolean

- Defined in node_modules/@types/mocha/index.d.ts:1371

### Optional stats

stats: Stats

- Defined in node_modules/@types/mocha/index.d.ts:1382

### suite

suite: Suite

- Defined in node_modules/@types/mocha/index.d.ts:1370

### Optional test

test: Test

- Defined in node_modules/@types/mocha/index.d.ts:1380

### total

total: number

- Defined in node_modules/@types/mocha/index.d.ts:1372

## Methods

### abort

- abort(): this

- - Defined in node_modules/@types/mocha/index.d.ts:1429

  Cleanly abort execution.

  see

    https://mochajs.org/api/Mocha.Runner.html#.Runner#abort

  #### Returns this

### addListener

- addListener(event: "waiting", listener: function): this
- addListener(event: "start", listener: function): this
- addListener(event: "end", listener: function): this
- addListener(event: "suite", listener: function): this
- addListener(event: "suite end", listener: function): this
- addListener(event: "test", listener: function): this
- addListener(event: "test end", listener: function): this
- addListener(event: "hook", listener: function): this
- addListener(event: "hook end", listener: function): this
- addListener(event: "pass", listener: function): this
- addListener(event: "fail", listener: function): this
- addListener(event: "pending", listener: function): this
- addListener(event: string, listener: function): this

- Overrides EventEmitter.addListener

  - Defined in node_modules/@types/mocha/index.d.ts:1546

  #### Parameters

  - ##### event: "waiting"

  - ##### listener: function

    - - (rootSuite: Suite): void

      - #### Parameters

        - ##### rootSuite: Suite

        #### Returns void

  #### Returns this

- Overrides EventEmitter.addListener

  - Defined in node_modules/@types/mocha/index.d.ts:1557

  #### Parameters

  - ##### event: "start"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1568

  #### Parameters

  - ##### event: "end"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1579

  #### Parameters

  - ##### event: "suite"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1590

  #### Parameters

  - ##### event: "suite end"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1601

  #### Parameters

  - ##### event: "test"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1612

  #### Parameters

  - ##### event: "test end"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1623

  #### Parameters

  - ##### event: "hook"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1634

  #### Parameters

  - ##### event: "hook end"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1645

  #### Parameters

  - ##### event: "pass"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1656

  #### Parameters

  - ##### event: "fail"

  - ##### listener: function

    - - (test: Test, err: any): void

      - #### Parameters

        - ##### test: Test

        - ##### err: any

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1667

  #### Parameters

  - ##### event: "pending"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1678

  #### Parameters

  - ##### event: string

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### Protected checkGlobals

- checkGlobals(test: Test): void

- - Defined in node_modules/@types/mocha/index.d.ts:1455

  Check for global variable leaks.

  see

    https://mochajs.org/api/Mocha.Runner.html#checkGlobals

  #### Parameters

  - ##### test: Test

  #### Returns void

### emit

- emit(name: "waiting", rootSuite: Suite): boolean
- emit(name: "start"): boolean
- emit(name: "end"): boolean
- emit(name: "suite", suite: Suite): boolean
- emit(name: "suite end", suite: Suite): boolean
- emit(name: "test", test: Test): boolean
- emit(name: "test end", test: Test): boolean
- emit(name: "hook", hook: Hook): boolean
- emit(name: "hook end", hook: Hook): boolean
- emit(name: "pass", test: Test): boolean
- emit(name: "fail", test: Test, err: any): boolean
- emit(name: "pending", test: Test): boolean
- emit(name: string, ...args: any[]): boolean

- Overrides EventEmitter.emit

  - Defined in node_modules/@types/mocha/index.d.ts:1550

  #### Parameters

  - ##### name: "waiting"

  - ##### rootSuite: Suite

  #### Returns boolean

- Overrides EventEmitter.emit

  - Defined in node_modules/@types/mocha/index.d.ts:1561

  #### Parameters

  - ##### name: "start"

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1572

  #### Parameters

  - ##### name: "end"

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1583

  #### Parameters

  - ##### name: "suite"

  - ##### suite: Suite

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1594

  #### Parameters

  - ##### name: "suite end"

  - ##### suite: Suite

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1605

  #### Parameters

  - ##### name: "test"

  - ##### test: Test

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1616

  #### Parameters

  - ##### name: "test end"

  - ##### test: Test

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1627

  #### Parameters

  - ##### name: "hook"

  - ##### hook: Hook

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1638

  #### Parameters

  - ##### name: "hook end"

  - ##### hook: Hook

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1649

  #### Parameters

  - ##### name: "pass"

  - ##### test: Test

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1660

  #### Parameters

  - ##### name: "fail"

  - ##### test: Test

  - ##### err: any

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1671

  #### Parameters

  - ##### name: "pending"

  - ##### test: Test

  #### Returns boolean

- - Defined in node_modules/@types/mocha/index.d.ts:1682

  #### Parameters

  - ##### name: string

  - ##### Rest ...args: any[]

  #### Returns boolean

### eventNames

- eventNames(): Array<string | symbol>

- Inherited from EventEmitter.eventNames

  Overrides EventEmitter.eventNames

  - Defined in node_modules/@types/node/globals.d.ts:594

  #### Returns Array<string | symbol>

### Protected fail

- fail(test: Test, err: any): void

- - Defined in node_modules/@types/mocha/index.d.ts:1462

  Fail the given `test`.

  see

    https://mochajs.org/api/Mocha.Runner.html#fail

  #### Parameters

  - ##### test: Test

  - ##### err: any

  #### Returns void

### Protected failHook

- failHook(hook: Hook, err: any): void

- - Defined in node_modules/@types/mocha/index.d.ts:1482

  Fail the given `hook` with `err`.

  Hook failures work in the following pattern:

  - If bail, then exit
  - Failed `before` hook skips all tests in a suite and subsuites, but jumps to corresponding `after` hook
  - Failed `before each` hook skips remaining tests in a suite and jumps to corresponding `after each` hook, which is run only once
  - Failed `after` hook does not alter execution order
  - Failed `after each` hook skips remaining tests in a suite and subsuites, but executes other `after each` hooks
  see

    https://mochajs.org/api/Mocha.Runner.html#failHook

  #### Parameters

  - ##### hook: Hook

  - ##### err: any

  #### Returns void

### getMaxListeners

- getMaxListeners(): number

- Inherited from EventEmitter.getMaxListeners

  Overrides EventEmitter.getMaxListeners

  - Defined in node_modules/@types/node/globals.d.ts:586

  #### Returns number

### Protected globalProps

- globalProps(): string[]

- - Defined in node_modules/@types/mocha/index.d.ts:1448

  Return a list of global properties.

  see

    https://mochajs.org/api/Mocha.Runner.html#globalProps

  #### Returns string[]

### globals

- globals(): string[]
- globals(arr: ReadonlyArray<string>): this

- - Defined in node_modules/@types/mocha/index.d.ts:1408

  Gets the allowed globals.

  see

    https://mochajs.org/api/Mocha.Runner.html#.Runner#globals

  #### Returns string[]

- - Defined in node_modules/@types/mocha/index.d.ts:1415

  Allow the given `arr` of globals.

  see

    https://mochajs.org/api/Mocha.Runner.html#.Runner#globals

  #### Parameters

  - ##### arr: ReadonlyArray<string>

  #### Returns this

### grep

- grep(re: RegExp, invert: boolean): this

- - Defined in node_modules/@types/mocha/index.d.ts:1390

  Run tests with full titles matching `re`. Updates runner.total with number of tests matched.

  see

    https://mochajs.org/api/Mocha.Runner.html#.Runner#grep

  #### Parameters

  - ##### re: RegExp

  - ##### invert: boolean

  #### Returns this

### grepTotal

- grepTotal(suite: Suite): number
- grepTotal(suite: ISuite): number

- - Defined in node_modules/@types/mocha/index.d.ts:1398

  Returns the number of tests matching the grep search for the given suite.

  see

    https://mochajs.org/api/Mocha.Runner.html#.Runner#grepTotal

  #### Parameters

  - ##### suite: Suite

  #### Returns number

- - Defined in node_modules/@types/mocha/index.d.ts:1401
  deprecated

    Use the overload that accepts `Mocha.Suite` instead.

  #### Parameters

  - ##### suite: ISuite

  #### Returns number

### Protected hook

- hook(name: string, fn: function): void

- - Defined in node_modules/@types/mocha/index.d.ts:1489

  Run hook `name` callbacks and then invoke `fn()`.

  see

    https://mochajs.org/api/Mocha.Runner.html#hook

  #### Parameters

  - ##### name: string

  - ##### fn: function

    - - (): void

      - #### Returns void

### Protected hookDown

- hookDown(name: string, fn: function): void

- - Defined in node_modules/@types/mocha/index.d.ts:1511

  Run hooks from the bottom up.

  see

    https://mochajs.org/api/Mocha.Runner.html#hookDown

  #### Parameters

  - ##### name: string

  - ##### fn: function

    - - (err?: any, errSuite?: Suite): void

      - #### Parameters

        - ##### Optional err: any

        - ##### Optional errSuite: Suite

        #### Returns void

### Protected hookUp

- hookUp(name: string, fn: function): void

- - Defined in node_modules/@types/mocha/index.d.ts:1504

  Run hooks from the top level down.

  see

    https://mochajs.org/api/Mocha.Runner.html#hookUp

  #### Parameters

  - ##### name: string

  - ##### fn: function

    - - (err?: any, errSuite?: Suite): void

      - #### Parameters

        - ##### Optional err: any

        - ##### Optional errSuite: Suite

        #### Returns void

### Protected hooks

- hooks(name: string, suites: Suite[], fn: function): void

- - Defined in node_modules/@types/mocha/index.d.ts:1497

  Run hook `name` for the given array of `suites` in order, and callback `fn(err, errSuite)`.

  see

    https://mochajs.org/api/Mocha.Runner.html#hooks

  #### Parameters

  - ##### name: string

  - ##### suites: Suite[]

  - ##### fn: function

    - - (err?: any, errSuite?: Suite): void

      - #### Parameters

        - ##### Optional err: any

        - ##### Optional errSuite: Suite

        #### Returns void

### listenerCount

- listenerCount(type: string | symbol): number

- Inherited from EventEmitter.listenerCount

  Overrides EventEmitter.listenerCount

  - Defined in node_modules/@types/node/globals.d.ts:590

  #### Parameters

  - ##### type: string | symbol

  #### Returns number

### listeners

- listeners(event: string | symbol): Function[]

- Inherited from EventEmitter.listeners

  Overrides EventEmitter.listeners

  - Defined in node_modules/@types/node/globals.d.ts:587

  #### Parameters

  - ##### event: string | symbol

  #### Returns Function[]

### off

- off(event: string | symbol, listener: function): this

- Inherited from EventEmitter.off

  Overrides EventEmitter.off

  - Defined in node_modules/@types/node/globals.d.ts:583

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### on

- on(event: "waiting", listener: function): this
- on(event: "start", listener: function): this
- on(event: "end", listener: function): this
- on(event: "suite", listener: function): this
- on(event: "suite end", listener: function): this
- on(event: "test", listener: function): this
- on(event: "test end", listener: function): this
- on(event: "hook", listener: function): this
- on(event: "hook end", listener: function): this
- on(event: "pass", listener: function): this
- on(event: "fail", listener: function): this
- on(event: "pending", listener: function): this
- on(event: string, listener: function): this

- Overrides EventEmitter.on

  - Defined in node_modules/@types/mocha/index.d.ts:1544

  #### Parameters

  - ##### event: "waiting"

  - ##### listener: function

    - - (rootSuite: Suite): void

      - #### Parameters

        - ##### rootSuite: Suite

        #### Returns void

  #### Returns this

- Overrides EventEmitter.on

  - Defined in node_modules/@types/mocha/index.d.ts:1555

  #### Parameters

  - ##### event: "start"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1566

  #### Parameters

  - ##### event: "end"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1577

  #### Parameters

  - ##### event: "suite"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1588

  #### Parameters

  - ##### event: "suite end"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1599

  #### Parameters

  - ##### event: "test"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1610

  #### Parameters

  - ##### event: "test end"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1621

  #### Parameters

  - ##### event: "hook"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1632

  #### Parameters

  - ##### event: "hook end"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1643

  #### Parameters

  - ##### event: "pass"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1654

  #### Parameters

  - ##### event: "fail"

  - ##### listener: function

    - - (test: Test, err: any): void

      - #### Parameters

        - ##### test: Test

        - ##### err: any

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1665

  #### Parameters

  - ##### event: "pending"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1676

  #### Parameters

  - ##### event: string

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### once

- once(event: "waiting", listener: function): this
- once(event: "start", listener: function): this
- once(event: "end", listener: function): this
- once(event: "suite", listener: function): this
- once(event: "suite end", listener: function): this
- once(event: "test", listener: function): this
- once(event: "test end", listener: function): this
- once(event: "hook", listener: function): this
- once(event: "hook end", listener: function): this
- once(event: "pass", listener: function): this
- once(event: "fail", listener: function): this
- once(event: "pending", listener: function): this
- once(event: string, listener: function): this

- Overrides EventEmitter.once

  - Defined in node_modules/@types/mocha/index.d.ts:1545

  #### Parameters

  - ##### event: "waiting"

  - ##### listener: function

    - - (rootSuite: Suite): void

      - #### Parameters

        - ##### rootSuite: Suite

        #### Returns void

  #### Returns this

- Overrides EventEmitter.once

  - Defined in node_modules/@types/mocha/index.d.ts:1556

  #### Parameters

  - ##### event: "start"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1567

  #### Parameters

  - ##### event: "end"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1578

  #### Parameters

  - ##### event: "suite"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1589

  #### Parameters

  - ##### event: "suite end"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1600

  #### Parameters

  - ##### event: "test"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1611

  #### Parameters

  - ##### event: "test end"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1622

  #### Parameters

  - ##### event: "hook"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1633

  #### Parameters

  - ##### event: "hook end"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1644

  #### Parameters

  - ##### event: "pass"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1655

  #### Parameters

  - ##### event: "fail"

  - ##### listener: function

    - - (test: Test, err: any): void

      - #### Parameters

        - ##### test: Test

        - ##### err: any

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1666

  #### Parameters

  - ##### event: "pending"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1677

  #### Parameters

  - ##### event: string

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### Protected parents

- parents(): Suite[]

- - Defined in node_modules/@types/mocha/index.d.ts:1518

  Return an array of parent Suites from closest to furthest.

  see

    https://mochajs.org/api/Mocha.Runner.html#parents

  #### Returns Suite[]

### prependListener

- prependListener(event: "waiting", listener: function): this
- prependListener(event: "start", listener: function): this
- prependListener(event: "end", listener: function): this
- prependListener(event: "suite", listener: function): this
- prependListener(event: "suite end", listener: function): this
- prependListener(event: "test", listener: function): this
- prependListener(event: "test end", listener: function): this
- prependListener(event: "hook", listener: function): this
- prependListener(event: "hook end", listener: function): this
- prependListener(event: "pass", listener: function): this
- prependListener(event: "fail", listener: function): this
- prependListener(event: "pending", listener: function): this
- prependListener(event: string, listener: function): this

- Overrides EventEmitter.prependListener

  - Defined in node_modules/@types/mocha/index.d.ts:1548

  #### Parameters

  - ##### event: "waiting"

  - ##### listener: function

    - - (rootSuite: Suite): void

      - #### Parameters

        - ##### rootSuite: Suite

        #### Returns void

  #### Returns this

- Overrides EventEmitter.prependListener

  - Defined in node_modules/@types/mocha/index.d.ts:1559

  #### Parameters

  - ##### event: "start"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1570

  #### Parameters

  - ##### event: "end"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1581

  #### Parameters

  - ##### event: "suite"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1592

  #### Parameters

  - ##### event: "suite end"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1603

  #### Parameters

  - ##### event: "test"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1614

  #### Parameters

  - ##### event: "test end"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1625

  #### Parameters

  - ##### event: "hook"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1636

  #### Parameters

  - ##### event: "hook end"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1647

  #### Parameters

  - ##### event: "pass"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1658

  #### Parameters

  - ##### event: "fail"

  - ##### listener: function

    - - (test: Test, err: any): void

      - #### Parameters

        - ##### test: Test

        - ##### err: any

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1669

  #### Parameters

  - ##### event: "pending"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1680

  #### Parameters

  - ##### event: string

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### prependOnceListener

- prependOnceListener(event: "waiting", listener: function): this
- prependOnceListener(event: "start", listener: function): this
- prependOnceListener(event: "end", listener: function): this
- prependOnceListener(event: "suite", listener: function): this
- prependOnceListener(event: "suite end", listener: function): this
- prependOnceListener(event: "test", listener: function): this
- prependOnceListener(event: "test end", listener: function): this
- prependOnceListener(event: "hook", listener: function): this
- prependOnceListener(event: "hook end", listener: function): this
- prependOnceListener(event: "pass", listener: function): this
- prependOnceListener(event: "fail", listener: function): this
- prependOnceListener(event: "pending", listener: function): this
- prependOnceListener(event: string, listener: function): this

- Overrides EventEmitter.prependOnceListener

  - Defined in node_modules/@types/mocha/index.d.ts:1549

  #### Parameters

  - ##### event: "waiting"

  - ##### listener: function

    - - (rootSuite: Suite): void

      - #### Parameters

        - ##### rootSuite: Suite

        #### Returns void

  #### Returns this

- Overrides EventEmitter.prependOnceListener

  - Defined in node_modules/@types/mocha/index.d.ts:1560

  #### Parameters

  - ##### event: "start"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1571

  #### Parameters

  - ##### event: "end"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1582

  #### Parameters

  - ##### event: "suite"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1593

  #### Parameters

  - ##### event: "suite end"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1604

  #### Parameters

  - ##### event: "test"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1615

  #### Parameters

  - ##### event: "test end"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1626

  #### Parameters

  - ##### event: "hook"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1637

  #### Parameters

  - ##### event: "hook end"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1648

  #### Parameters

  - ##### event: "pass"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1659

  #### Parameters

  - ##### event: "fail"

  - ##### listener: function

    - - (test: Test, err: any): void

      - #### Parameters

        - ##### test: Test

        - ##### err: any

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1670

  #### Parameters

  - ##### event: "pending"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1681

  #### Parameters

  - ##### event: string

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### rawListeners

- rawListeners(event: string | symbol): Function[]

- Inherited from EventEmitter.rawListeners

  Overrides EventEmitter.rawListeners

  - Defined in node_modules/@types/node/globals.d.ts:588

  #### Parameters

  - ##### event: string | symbol

  #### Returns Function[]

### removeAllListeners

- removeAllListeners(event?: string | symbol): this

- Inherited from EventEmitter.removeAllListeners

  Overrides EventEmitter.removeAllListeners

  - Defined in node_modules/@types/node/globals.d.ts:584

  #### Parameters

  - ##### Optional event: string | symbol

  #### Returns this

### removeListener

- removeListener(event: "waiting", listener: function): this
- removeListener(event: "start", listener: function): this
- removeListener(event: "end", listener: function): this
- removeListener(event: "suite", listener: function): this
- removeListener(event: "suite end", listener: function): this
- removeListener(event: "test", listener: function): this
- removeListener(event: "test end", listener: function): this
- removeListener(event: "hook", listener: function): this
- removeListener(event: "hook end", listener: function): this
- removeListener(event: "pass", listener: function): this
- removeListener(event: "fail", listener: function): this
- removeListener(event: "pending", listener: function): this
- removeListener(event: string, listener: function): this

- Overrides EventEmitter.removeListener

  - Defined in node_modules/@types/mocha/index.d.ts:1547

  #### Parameters

  - ##### event: "waiting"

  - ##### listener: function

    - - (rootSuite: Suite): void

      - #### Parameters

        - ##### rootSuite: Suite

        #### Returns void

  #### Returns this

- Overrides EventEmitter.removeListener

  - Defined in node_modules/@types/mocha/index.d.ts:1558

  #### Parameters

  - ##### event: "start"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1569

  #### Parameters

  - ##### event: "end"

  - ##### listener: function

    - - (): void

      - #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1580

  #### Parameters

  - ##### event: "suite"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1591

  #### Parameters

  - ##### event: "suite end"

  - ##### listener: function

    - - (suite: Suite): void

      - #### Parameters

        - ##### suite: Suite

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1602

  #### Parameters

  - ##### event: "test"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1613

  #### Parameters

  - ##### event: "test end"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1624

  #### Parameters

  - ##### event: "hook"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1635

  #### Parameters

  - ##### event: "hook end"

  - ##### listener: function

    - - (hook: Hook): void

      - #### Parameters

        - ##### hook: Hook

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1646

  #### Parameters

  - ##### event: "pass"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1657

  #### Parameters

  - ##### event: "fail"

  - ##### listener: function

    - - (test: Test, err: any): void

      - #### Parameters

        - ##### test: Test

        - ##### err: any

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1668

  #### Parameters

  - ##### event: "pending"

  - ##### listener: function

    - - (test: Test): void

      - #### Parameters

        - ##### test: Test

        #### Returns void

  #### Returns this

- - Defined in node_modules/@types/mocha/index.d.ts:1679

  #### Parameters

  - ##### event: string

  - ##### listener: function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns this

### run

- run(fn?: undefined | function): this

- - Defined in node_modules/@types/mocha/index.d.ts:1422

  Run the root suite and invoke `fn(failures)` on completion.

  see

    https://mochajs.org/api/Mocha.Runner.html#.Runner#run

  #### Parameters

  - ##### Optional fn: undefined | function

  #### Returns this

### Protected runSuite

- runSuite(suite: Suite, fn: function): void

- - Defined in node_modules/@types/mocha/index.d.ts:1539

  Run the given `suite` and invoke the callback `fn()` when complete.

  see

    https://mochajs.org/api/Mocha.Runner.html#runSuite

  #### Parameters

  - ##### suite: Suite

  - ##### fn: function

    - - (errSuite?: Suite): void

      - #### Parameters

        - ##### Optional errSuite: Suite

        #### Returns void

### Protected runTest

- runTest(fn: Done): any

- - Defined in node_modules/@types/mocha/index.d.ts:1525

  Run the current test and callback `fn(err)`.

  see

    https://mochajs.org/api/Mocha.Runner.html#runTest

  #### Parameters

  - ##### fn: Done

  #### Returns any

### Protected runTests

- runTests(suite: Suite, fn: function): void

- - Defined in node_modules/@types/mocha/index.d.ts:1532

  Run tests in the given `suite` and invoke the callback `fn()` when complete.

  see

    https://mochajs.org/api/Mocha.Runner.html#runTests

  #### Parameters

  - ##### suite: Suite

  - ##### fn: function

    - - (errSuite?: Suite): void

      - #### Parameters

        - ##### Optional errSuite: Suite

        #### Returns void

### setMaxListeners

- setMaxListeners(n: number): this

- Inherited from EventEmitter.setMaxListeners

  Overrides EventEmitter.setMaxListeners

  - Defined in node_modules/@types/node/globals.d.ts:585

  #### Parameters

  - ##### n: number

  #### Returns this

### uncaught

- uncaught(err: any): void

- - Defined in node_modules/@types/mocha/index.d.ts:1436

  Handle uncaught exceptions.

  see

    https://mochajs.org/api/Mocha.Runner.html#uncaught

  #### Parameters

  - ##### err: any

  #### Returns void

### Static Protected immediately

- immediately(callback: Function): void

- - Defined in node_modules/@types/mocha/index.d.ts:1441

  Wrapper for setImmediate, process.nextTick, or browser polyfill.

  #### Parameters

  - ##### callback: Function

  #### Returns void

Generated using TypeDoc